define("epi-ecf-ui/contentediting/editors/epi-addon-tinymce/plugins/opti-gpt-generator/opti-gpt-generator", [
    //epi
    "epi-addon-tinymce/tinymce-loader",
    "epi/shell/command/_Command",
    "epi/shell/widget/dialog/Dialog",
    // Resources
    "epi/i18n!epi/cms/nls/commerce.widget.optiai",
    "epi-ecf-ui/widget/OptiAiDialogContent"
], function (
    tinymce,
    _Command,
    Dialog,
    res,
    OptiAiDialogContent) {

    tinymce.PluginManager.add("opti-gpt-generator", function (editor) {

        function optiGPTEditor() {

            var content = new OptiAiDialogContent({prompt: editor.getContent({format: 'text'})});
            var dialog = new Dialog({
                title: res.title,
                description: "",
                confirmActionText: res.save,
                content: content,
                dialogClass: "epi-dialog--wide"
            });

            dialog.on("execute", function () {
                var result = dijit.byId("epi-ai-result");
                var newContent = result.value.replace(/\r\n?|\n/g, '<br />');
                editor.focus();
                editor.setContent(newContent || "");
                editor.fire("change");
                dialog.hide();
            }.bind(this));

            dialog.show();
        }

        editor.ui.registry.addIcon("opti-iconAi", "<div class='opti-iconAi'></div>");

        // Register buttons
        editor.ui.registry.addButton("opti-gpt-generator", {
            text: res.name,
            tooltip: res.title,
            icon: "opti-iconAi",
            onAction: optiGPTEditor,
            onSetup: function (buttonApi) {
                function enableButton(e) {
                    var hasContent = !!editor.getContent({format: 'text'}).trim();
                    buttonApi.setEnabled(hasContent);
                }
                editor.on("init", enableButton);
                editor.on("change", enableButton);
                editor.on("keyup", enableButton);

                return function () {
                    editor.off("change", enableButton);
                    editor.off("init", enableButton); 
                    editor.off("keyup", enableButton);
                };
            }
        });

        return {
            getMetadata: function () {
                return {
                    name: "Optimizely GPT Generator",
                    url: "https://www.optimizely.com"
                };
            }
        };
    });
});
