require({cache:{
'url:epi-ecf-ui/widget/templates/OptiAiDialogContent.html':"﻿<div data-dojo-attach-point=\"optiAiDialogNode\">\r\n    <div style=\"margin-bottom:20px\">\r\n        <div>\r\n            <span class=\"epi-ai-label\" data-dojo-attach-point=\"promptLabel\"></span>\r\n            <div style=\"margin-top:5px\" data-dojo-attach-point=\"promptNode\"></div>\r\n            <div style=\"text-align: center;\" data-dojo-attach-point=\"createNewNode\"></div>\r\n        </div>\r\n    </div>\r\n    \r\n    <div style=\"margin-top:10px\">\r\n        <div style=\"padding-top: 5px;\">\r\n            <span class=\"epi-ai-label\" data-dojo-attach-point=\"resultLabel\"></span>\r\n            <div style=\"margin-top:5px\" data-dojo-attach-point=\"resultNode\"></div>\r\n            <div style=\"text-align: center;\" data-dojo-attach-point=\"actionNode\"></div>\r\n        </div>\r\n    </div>\r\n</div>"}});
define("epi-ecf-ui/widget/OptiAiDialogContent", [
    "dojo/_base/declare",
    "dojo/when",
    "dijit",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/form/Textarea",
    "dijit/form/Button",
    //dojox
    "dojox/widget/Standby",
    // Epi
    "epi/dependency",

    // template
    "dojo/text!./templates/OptiAiDialogContent.html",
    "epi/i18n!epi/cms/nls/commerce.widget.optiai"
], function (declare, when, dijit, _WidgetBase, _TemplatedMixin, Textarea, Button, Standby, dependency, template, res) {

    return declare([_WidgetBase, _TemplatedMixin], {
        // summary:
        //		The Optimizely GPT generate content dialog
        // tags:
        //      internal

        templateString: template,

        store: null,

        prompt: null,

        action: Object.freeze({
            create: "0",
            rewrite: "1",
            shorter: "2",
            longer:"3"
        }),

        postCreate: function() {
            this.inherited(arguments);
            if (!this.store) {
                this.store = dependency.resolve("epi.storeregistry").get("epi.commerce.optigpt");
            }

            this._setupPromptNode();
            this._setupGenerateButton();
            this._setupResultArea();
            this._setupActionButton();

            this._standby = new Standby({
                target: this.optiAiDialogNode,
                color: "#fff",
                zIndex: 9999,
                text: "<div class=\"oui-spinner\"></div>",
                centerIndicator: "text"
            }).placeAt(document.body);
            this._standby.startup();

            // Auto generate content
            this._generateContent(this.prompt, this.action.create);
        },

        _setupPromptNode: function () {
            this.promptLabel.innerHTML = res.prompttext;

            var promptText = new Textarea({
                id: "epi-ai-prompt",
                name: "epi-ai-prompt",
                value: this.prompt,
                readonly: "true",
                style: "min-width:860px; min-height: 150px; padding-top: 10px;"
            });
            promptText.placeAt(this.promptNode);
        },

        _setupGenerateButton: function () {
            var self = this;
            var generateButton = new Button({
                title: res.generatebuttontooltip,
                label: res.generatebutton,
                "class": "Salt",
                style:"margin-top: 5px;margin-left: 10px;",
                onClick: function () {
                    self._generateContent(self.prompt, self.action.create);
                }
            });
            generateButton.placeAt(this.createNewNode);
        },

        _setupResultArea: function () {
            this.resultLabel.innerHTML = res.result;

            var resultText = new Textarea({
                id: "epi-ai-result",
                name: "epi-ai-result",
                value: "",
                style: "min-width:860px; min-height: 200px; padding-top: 10px;"
            });
            resultText.placeAt(this.resultNode);
        },

        _setupActionButton: function () {
            var self = this;
            var rewriteButton = new Button({
                title: res.rewritebuttontooltip,
                label: res.rewritebutton,
                "class": "Salt",
                style: "margin-top: 5px;margin-left: 10px;",
                onClick: function () {
                    var property = dijit.byId("epi-ai-result");
                    self._generateContent(property.value, self.action.rewrite);
                }
            });

            var makeShorterButton = new Button({
                title: res.makeshoterbuttontooltip,
                label: res.makeshoterbutton,
                "class": "Salt",
                style: "margin-top: 5px;margin-left: 10px;",
                onClick: function () {
                    var property = dijit.byId("epi-ai-result");
                    self._generateContent(property.value, self.action.shorter);
                }
            });

            var makeLongerButton = new Button({
                title: res.makelongerbuttontooltip,
                label: res.makelongerbutton,
                "class": "Salt",
                style: "margin-top: 5px;margin-left: 10px;",
                onClick: function () {
                    var property = dijit.byId("epi-ai-result");
                    self._generateContent(property.value, self.action.longer);
                }
            });

            rewriteButton.placeAt(this.actionNode);
            makeShorterButton.placeAt(this.actionNode);
            makeLongerButton.placeAt(this.actionNode);
        },

        _showStandby: function (visible) {
            // summary:
            //      Set standby visibility.
            // tags:
            //      private

            if (!this._standby) {
                return;
            }
            if (visible) {
                if (!this._standby.isVisible()) {
                    this._standby.show();
                }
            } else {
                this._standby.hide();
            }
        },

        _generateContent: function (prompt, rewrite) {
            var self = this;
            self._showStandby(true);
            when(self.store.query({ content: prompt, rewrite: rewrite }), function (data) {
                var resultText = dijit.byId("epi-ai-result");
                resultText.set("value", data.content);
                self._showStandby(false);
            });
        }
    });
});
